function Initialize()
	Old1 = nil
	Old2 = nil
	OldImgNo = nil
	FileName = SKIN:GetVariable('FileName')
	MeterUpd = SKIN:GetMeter('MeterImgNameDisplayed')
end

function ShowName(ImgPath)
	Path, ImageName, Extension = string.match(ImgPath, "(.-)([^\\]-([^%.]+))$")
	ImgName = string.gsub(ImageName, "(.+)%.(.+)", "%1")
	return ImgName
end

function ReadFileContent()
	local ImagesNames = {}
	local Empty = {}
	for i = 1,4 do
		Empty[i] = " "
	end
	FilePath = SKIN:MakePathAbsolute(FileName)
	local File = io.open(FilePath, 'r')
	if File then
		for Line in File:lines() do
			if Line ~= '' then table.insert(ImagesNames, Line) end
		end
		File:close()
	end
	if #ImagesNames > 0 then
		return ImagesNames
	else
		return Empty
	end
end

function Update()
	local Images = {}
	Images = ReadFileContent()
	FilePath = SKIN:MakePathAbsolute(FileName)
	local New1 = SKIN:GetMeasure('Random1'):GetStringValue()
	local New2 = SKIN:GetMeasure('Random2'):GetStringValue()
	local NewImgNo = SKIN:GetMeasure('BinActionShowImageName'):GetValue()
	if OldImgNo ~= NewImgNo then
        	local File = io.open(FilePath, 'w')
		if NewImgNo == 1 then
			if Old1 ~= nil then File:write(Old1) end
			SKIN:Bang('!SetOption', 'MeterPrevImg1', 'ImageName', Old1)
			SKIN:Bang('!SetOption', 'MeterPreviousImgName1', 'Text', ShowName(Old1))
			SKIN:Bang('!SetVariable', 'PrevImage1', Old1)
		end
		if NewImgNo == 2 then
			if Old2 ~= nil then File:write(Old2) end
			SKIN:Bang('!SetOption', 'MeterPrevImg1', 'ImageName', Old2)
			SKIN:Bang('!SetOption', 'MeterPreviousImgName1', 'Text', ShowName(Old2))
			SKIN:Bang('!SetVariable', 'PrevImage1', Old2)
		end
		for i = 1,4 do File:write('\n'..Images[i]) end
		SKIN:Bang('!SetOption', 'MeterPrevImg2', 'ImageName', Images[1])
		SKIN:Bang('!SetOption', 'MeterPrevImg3', 'ImageName', Images[2])
		SKIN:Bang('!SetOption', 'MeterPrevImg4', 'ImageName', Images[3])
		SKIN:Bang('!SetOption', 'MeterPrevImg5', 'ImageName', Images[4])
		SKIN:Bang('!SetOption', 'MeterPreviousImgName2', 'Text', ShowName(Images[1]))
		SKIN:Bang('!SetOption', 'MeterPreviousImgName3', 'Text', ShowName(Images[2]))
		SKIN:Bang('!SetOption', 'MeterPreviousImgName4', 'Text', ShowName(Images[3]))
		SKIN:Bang('!SetOption', 'MeterPreviousImgName5', 'Text', ShowName(Images[4]))
		SKIN:Bang('!SetVariable', 'PrevImage2', Images[1])
		SKIN:Bang('!SetVariable', 'PrevImage3', Images[2])
		SKIN:Bang('!SetVariable', 'PrevImage4', Images[3])
		SKIN:Bang('!SetVariable', 'PrevImage5', Images[4])
		File:close()
	        Old1 = New1
        	Old2 = New2
		OldImgNo = NewImgNo
	end
end